GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})
PrefabFiles = {
	"saddle",
	"staffcastfx_mount",
	"brush",
	"saddlehorn",
	"saltlick",
	"beefalo_transform_fx",
	"beefaloherd_dst",
}
Assets = {	
		--actions
		Asset("ANIM", "anim/player_actions_unsaddle.zip"),
        Asset("ANIM", "anim/player_mount.zip"),
        Asset("ANIM", "anim/player_mount_travel.zip"),
        Asset("ANIM", "anim/player_mount_actions.zip"),
        Asset("ANIM", "anim/player_mount_actions_item.zip"),
        Asset("ANIM", "anim/player_mount_unique_actions.zip"),
        Asset("ANIM", "anim/player_mount_one_man_band.zip"),
        Asset("ANIM", "anim/player_mount_blowdart.zip"),
        Asset("ANIM", "anim/player_mount_shock.zip"),
        Asset("ANIM", "anim/player_mount_frozen.zip"),
        Asset("ANIM", "anim/player_mount_groggy.zip"),
        Asset("ANIM", "anim/player_mount_encumbered.zip"),
        Asset("ANIM", "anim/player_mount_sandstorm.zip"),
        Asset("ANIM", "anim/player_mount_hit_darkness.zip"),
        Asset("ANIM", "anim/player_mount_emotes.zip"),
        Asset("ANIM", "anim/player_mount_emotes_dance0.zip"),
        Asset("ANIM", "anim/player_mount_emotesxl.zip"),
        Asset("ANIM", "anim/player_mount_emotes_sit.zip"),
        Asset("ANIM", "anim/player_mount_bow.zip"),
		--imgaes
		Asset( "ATLAS", "images/inventoryimages/saddle_basic.xml" ),
		Asset( "ATLAS", "images/inventoryimages/saddle_war.xml" ),
		Asset( "ATLAS", "images/inventoryimages/saddle_race.xml" ),
		Asset( "ATLAS", "images/inventoryimages/brush.xml" ),
		Asset( "ATLAS", "images/inventoryimages/saddlehorn.xml" ),
		Asset( "ATLAS", "images/inventoryimages/saltlick.xml" ),
		Asset( "ATLAS", "images/dismountniu.xml" ),	
		Asset( "ATLAS", "images/678.xml" ),		

		---为了更好的表现动画 官方人物骑牛使用联机的build （忽略沃尔夫冈和mod角色）
		Asset("ANIM", "anim/wathgrithr_dst.zip"),
        Asset("ANIM", "anim/waxwell_dst.zip"),
		Asset("ANIM", "anim/webber_dst.zip"),
        Asset("ANIM", "anim/wendy_dst.zip"),
		Asset("ANIM", "anim/wes_dst.zip"),
        Asset("ANIM", "anim/wickerbottom_dst.zip"),
		Asset("ANIM", "anim/willow_dst.zip"),
        Asset("ANIM", "anim/wilson_dst.zip"),
		Asset("ANIM", "anim/woodie_dst.zip"),
        Asset("ANIM", "anim/wx78_dst.zip"),
		--sound
		Asset("SOUNDPACKAGE", "sound/dsbeefalo.fev"),
		Asset("SOUND", "sound/dsbeefalo.fsb"),
}

----just for the mod Puppet
if GLOBAL.KnownModIndex:IsModEnabled("workshop-1419580556") then
	table.insert(Assets, Asset("ANIM", "anim/puppet_butterfly.zip"))
	table.insert(Assets, Asset("ANIM", "anim/puppet.zip"))
end

local require = GLOBAL.require
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local GetWorld = GLOBAL.GetWorld
local GetClock = GLOBAL.GetClock
local Action = GLOBAL.Action
local ActionHandler = GLOBAL.ActionHandler
local ACTIONS = GLOBAL.ACTIONS
local State = GLOBAL.State
local DEGREES = GLOBAL.DEGREES
local TimeEvent = GLOBAL.TimeEvent
local EventHandler = GLOBAL.EventHandler
local FRAMES = GLOBAL.FRAMES
local Vector3 = GLOBAL.Vector3
local SpawnPrefab = GLOBAL.SpawnPrefab
local ActionHandler = GLOBAL.ActionHandler
local GetRandomWithVariance = GLOBAL.GetRandomWithVariance
modimport("scripts/stategraphs/SGqiniu.lua")

local ROUGHAGE = 
{
	{prefab = "cutgrass" , health = TUNING.HEALING_TINY , hunger = TUNING.CALORIES_TINY/2},
	{prefab = "cutreeds" , health =TUNING.HEALING_TINY  , hunger = TUNING.CALORIES_TINY/2 },
	{prefab = "twigs" , health =TUNING.HEALING_TINY/2  , hunger = TUNING.CALORIES_TINY },
	{prefab = "bamboo" , health =TUNING.HEALING_TINY/2  , hunger = TUNING.CALORIES_TINY },
}
for k,v in pairs(ROUGHAGE) do  
	AddPrefabPostInit(v.prefab, function(inst)
		if not inst.components.edible then
		inst:AddComponent("edible")
		end
		inst.components.edible.foodtype = "ROUGHAGE"
	    inst.components.edible.healthvalue = v.health
	    inst.components.edible.hungervalue = v.hunger
	end)
end

AddPrefabPostInit("world", function(inst)
		inst:AddComponent("uniqueprefabids")
end)
local function showui(inst)
	if inst.HUD ~= GLOBAL.TheFrontEnd:GetActiveScreen() then return end
	if not inst.HUD.shown then return end
		if inst.HUD.controls.dismountniu then
			inst.HUD.controls.dismountniu:Show()
			inst.HUD.controls.dismountniu:StartUpdating()
		end
end
local function hideui(inst)
	if inst.HUD ~= GLOBAL.TheFrontEnd:GetActiveScreen() then return end
	if not inst.HUD.shown then return end
		if inst.HUD.controls.dismountniu then
			inst.HUD.controls.dismountniu:Close()
			inst.HUD.controls.dismountniu:StopUpdating()
		end
end
local function qiniu(inst)
	    inst:AddTag("_rider")
		inst:AddComponent("rider")
		inst.components.rider:ActualDismount()
		inst:ListenForEvent("mountedniu", showui)
		inst:ListenForEvent("dismountniu", hideui)
end
AddPlayerPostInit(qiniu)
---------TUNING 
TUNING.BEEFALO_HEALTH = 500  --500 for ds
TUNING.BEEFALO_HEALTH_REGEN_PERIOD = 10
TUNING.BEEFALO_HEALTH_REGEN = (500)/(480*3)*10
TUNING. BEEFALO_DAMAGE =
    {
            DEFAULT = 34,
            RIDER = 25,
            ORNERY = 50,
            PUDGY = 20,
    }
TUNING.BEEFALO_MATING_SEASON_LENGTH = 3
TUNING.BEEFALO_MATING_SEASON_WAIT = 20
TUNING.BEEFALO_MATING_SEASON_BABYDELAY = 480*1.5
TUNING.BEEFALO_MATING_SEASON_BABYDELAY_VARIANCE = 0.5*480
TUNING.BEEFALO_TARGET_DIST = 5
TUNING.BEEFALO_CHASE_DIST = 30
TUNING.BEEFALO_FOLLOW_TIME = 30
TUNING.BEEFALO_HUNGER = (75*4)/0.8 
TUNING.BEEFALO_HUNGER_RATE = (75*4)/480 
TUNING.BEEFALO_WALK_SPEED = 1.0
TUNING.BEEFALO_RUN_SPEED =
        {
            DEFAULT = 7,
            RIDER = 8.0,
            ORNERY = 7.0,
            PUDGY = 6.5,
        }
TUNING.BEEFALO_HAIR_GROWTH_DAYS = 3
TUNING.BEEFALO_SADDLEABLE_OBEDIENCE = 0.1
TUNING.BEEFALO_KEEP_SADDLE_OBEDIENCE = 0.4
TUNING.BEEFALO_MIN_BUCK_OBEDIENCE = 0.5
TUNING.BEEFALO_MIN_BUCK_TIME = 50
TUNING.BEEFALO_MAX_BUCK_TIME = 800
TUNING.BEEFALO_BUCK_TIME_VARIANCE = 3
TUNING.BEEFALO_MIN_DOMESTICATED_OBEDIENCE =
        {
            DEFAULT = 0.8,
            ORNERY = 0.45,
            RIDER = 0.95,
            PUDGY = 0.6,
        }
TUNING.BEEFALO_BUCK_TIME_MOOD_MULT = 0.2
TUNING.BEEFALO_BUCK_TIME_UNDOMESTICATED_MULT = 0.3
TUNING.BEEFALO_BUCK_TIME_NUDE_MULT = 0.2
TUNING.BEEFALO_BEG_HUNGER_PERCENT = 0.45
TUNING.BEEFALO_DOMESTICATION_STARVE_OBEDIENCE = -1/(480*1)
TUNING.BEEFALO_DOMESTICATION_FEED_OBEDIENCE = 0.1
TUNING.BEEFALO_DOMESTICATION_OVERFEED_OBEDIENCE = -0.3
TUNING.BEEFALO_DOMESTICATION_ATTACKED_BY_PLAYER_OBEDIENCE = -1
TUNING.BEEFALO_DOMESTICATION_BRUSHED_OBEDIENCE = 0.4
TUNING.BEEFALO_DOMESTICATION_SHAVED_OBEDIENCE = -1
TUNING.BEEFALO_DOMESTICATION_LOSE_DOMESTICATION = -1/(480*4)
TUNING.BEEFALO_DOMESTICATION_GAIN_DOMESTICATION = 1/(480*20)
TUNING.BEEFALO_DOMESTICATION_MAX_LOSS_DAYS = 10
TUNING.BEEFALO_DOMESTICATION_OVERFEED_DOMESTICATION = -0.01
TUNING.BEEFALO_DOMESTICATION_ATTACKED_DOMESTICATION = 0
TUNING.BEEFALO_DOMESTICATION_ATTACKED_OBEDIENCE = -0.01
TUNING.BEEFALO_DOMESTICATION_ATTACKED_BY_PLAYER_DOMESTICATION = -0.3
TUNING.BEEFALO_DOMESTICATION_BRUSHED_DOMESTICATION = (1-(15/20))/15
TUNING.BEEFALO_PUDGY_WELLFED = 1/(480*5)
TUNING.BEEFALO_PUDGY_OVERFEED = 0.02
TUNING.BEEFALO_RIDER_RIDDEN = 1/(480*5)
TUNING.BEEFALO_ORNERY_DOATTACK = 0.004
TUNING.BEEFALO_ORNERY_ATTACKED = 0.004
TUNING.BEEFALOHERD_RANGE = 40
TUNING.BEEFALOHERD_MAX_IN_RANGE = 16
TUNING.BABYBEEFALO_HEALTH = 300
TUNING.BABYBEEFALO_GROW_TIME = {base=3*300, random=2*300}
TUNING.SADDLEHORN_DAMAGE = 34*.5
TUNING.BRUSH_DAMAGE = 34*.8
TUNING.SADDLE_BASIC_BONUS_DAMAGE = 0
TUNING.SADDLE_WAR_BONUS_DAMAGE = 16
TUNING.SADDLE_RACE_BONUS_DAMAGE = 0
TUNING.SADDLE_BASIC_USES = 5
TUNING.SADDLE_WAR_USES = 8
TUNING.SADDLE_RACE_USES = 8
TUNING.SADDLE_BASIC_SPEEDMULT = 2.4
TUNING.SADDLE_WAR_SPEEDMULT = 1.5
TUNING.SADDLE_RACE_SPEEDMULT = 3.3
TUNING.SALTLICK_CHECK_DIST = 20
TUNING.SALTLICK_USE_DIST = 4
TUNING.SALTLICK_DURATION = 480 / 8
TUNING.SALTLICK_MAX_LICKS = 240
TUNING.SALTLICK_BEEFALO_USES = 2
TUNING.SALTLICK_KOALEFANT_USES = 4
TUNING.SALTLICK_LIGHTNINGGOAT_USES = 1
TUNING.SALTLICK_DEER_USES = 1
	GLOBAL.TENDENCY =
{
    DEFAULT = "DEFAULT",
    ORNERY = "ORNERY",
    RIDER = "RIDER",
    PUDGY = "PUDGY",
}
-------STRINGS
STRINGS.CHARACTERS.GENERIC.ACTIONFAIL.MOUNTNIU =
        {
            TARGETINCOMBAT = "I know better than to bother an angry beefalo!",
            INUSE = "Someone beat me to the saddle!",
        }
STRINGS.CHARACTERS.GENERIC.ACTIONFAIL.SADDLE =
        {
            TARGETINCOMBAT = "It won't let me do that while it's angry."
        }
STRINGS.CHARACTERS.GENERIC.ANNOUNCE_MOUNT_LOWHEALTH = "This beast seems to be wounded."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BEEFALO =
		{
			FOLLOWER = "He's coming along peacefully.",
			GENERIC = "It's a beefalo!",
			NAKED = "Aww, he's so sad.",
			SLEEPING = "These guys are really heavy sleepers.",
            DOMESTICATED = "This one is slightly less smelly than the others.",
            ORNERY = "It looks deeply angry.",
            RIDER = "This fellow appears quite ridable.",
            PUDGY = "Hmmm, there may be too much food inside it.",
		}
STRINGS.NAMES.BRUSH = "Brush"
STRINGS.RECIPE_DESC.BRUSH = "Relieve beefalo of their hair buildup." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BRUSH = "I bet the beefalo really like this."

STRINGS.NAMES.SALTLICK = "Salt Lick"
STRINGS.RECIPE_DESC.SALTLICK = "Keep your livestock content." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SALTLICK = "How many licks does it take to get to the center?"

STRINGS.NAMES.SADDLEHORN = "Saddlehorn"
STRINGS.RECIPE_DESC.SADDLEHORN = "Pry that saddle off." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SADDLEHORN = "This could take a saddle off."

STRINGS.NAMES.SADDLE_BASIC = "Saddle"
STRINGS.RECIPE_DESC.SADDLE_BASIC = "Lets you sit on animals. In theory." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SADDLE_BASIC = "That'll allow the mounting of some smelly animal."

STRINGS.NAMES.SADDLE_WAR = "War Saddle"
STRINGS.RECIPE_DESC.SADDLE_WAR = "A throne for the boss of the battlefield." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SADDLE_WAR = "The only problem is the saddle sores."

STRINGS.NAMES.SADDLE_RACE = "Glossamer Saddle"
STRINGS.RECIPE_DESC.SADDLE_RACE = "Offsets the time spent making it. Maybe." 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SADDLE_RACE = "This saddle really flies!"

-------newrecipes
AddMinimapAtlas("images/inventoryimages/saltlick.xml")	
	local saddlehorn = Recipe("saddlehorn", {Ingredient("twigs", 2), Ingredient("boneshard", 2), Ingredient("feather_crow", 1)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO)
	saddlehorn.atlas = "images/inventoryimages/saddlehorn.xml"
	local saddle_basic = Recipe("saddle_basic", {Ingredient("beefalowool", 4), Ingredient("pigskin", 4), Ingredient("goldnugget", 4)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO)
	saddle_basic.atlas = "images/inventoryimages/saddle_basic.xml"
	local saddle_war = Recipe("saddle_war", {Ingredient("rabbit", 4), Ingredient("spear", 2), Ingredient("log", 10)},
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO)
	saddle_war.atlas = "images/inventoryimages/saddle_war.xml"
	local saddle_race = Recipe("saddle_race", {Ingredient("livinglog", 2), Ingredient("silk", 4), Ingredient("butterflywings", 68)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO)
	saddle_race.atlas = "images/inventoryimages/saddle_race.xml"
	local brush = Recipe("brush", {Ingredient("razor", 1), Ingredient("walrus_tusk", 1), Ingredient("goldnugget", 2)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO)
	brush.atlas = "images/inventoryimages/brush.xml"
	
	if ACTIONS.HACK ~= nil then
	local saltlick = Recipe("saltlick", {Ingredient("boards", 2), Ingredient("nitre", 4)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO, GLOBAL.RECIPE_GAME_TYPE.COMMON, "saltlick_placer")
	saltlick.atlas = "images/inventoryimages/saltlick.xml"
	else
	local saltlick = Recipe("saltlick", {Ingredient("boards", 2), Ingredient("nitre", 4)}, 
	RECIPETABS.TOOLS,  TECH.SCIENCE_TWO,  "saltlick_placer")
	saltlick.atlas = "images/inventoryimages/saltlick.xml"	
	end
	
local SADDLE = Action(1 )
local UNSADDLE = Action(3, false ,false )
SADDLE.id = "SADDLE"
SADDLE.str = "Saddle"
UNSADDLE.id = "UNSADDLE"
UNSADDLE.str = "Unsaddle"
SADDLE.fn = function(act) 
	if act.target.components.combat ~= nil and act.target.components.combat.target ~=nil then
        return false, "TARGETINCOMBAT"
    elseif act.target.components.rideable ~= nil then
        act.doer:PushEvent("saddle", { target = act.target })
        act.doer.components.inventory:RemoveItem(act.invobject)
        act.target.components.rideable:SetSaddle(act.doer, act.invobject)
        return true
    end
end
UNSADDLE.fn = function(act)
    if act.target.components.combat ~= nil and act.target.components.combat.target ~=nil then
        return false, "TARGETINCOMBAT"
    elseif act.target.components.rideable ~= nil then
        act.doer:PushEvent("saddle", { target = act.target })
        act.target.components.rideable:SetSaddle(act.doer, nil)
        return true
    end
end
AddAction(SADDLE)
AddAction(UNSADDLE)
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.SADDLE, "doshortaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.UNSADDLE, "unsaddle"))
 ----------mount and dismount
local  MOUNTNIU = Action( 1,  false , true )
local  DISMOUNTNIU = Action(1, true, true )
MOUNTNIU.id = "MOUNTNIU"
MOUNTNIU.str = "Mount"
DISMOUNTNIU.id = "DISMOUNTNIU"
DISMOUNTNIU.str = "Dismount"
MOUNTNIU.fn = function(act)
    if act.target.components.combat ~= nil and act.target.components.combat.target ~=nil then
        return false, "TARGETINCOMBAT"
    elseif act.target.components.rideable == nil
        or not act.target.components.rideable.canride
        or (act.target.components.health ~= nil and
            act.target.components.health:IsDead())
        or (act.target.components.freezable and
            act.target.components.freezable:IsFrozen()) then
        return false
    elseif act.target.components.rideable:IsBeingRidden() then
        return false, "INUSE"
    end
    act.doer.components.rider:Mount(act.target)
    return true
end

DISMOUNTNIU.fn = function(act)
    if act.doer == act.target and act.doer.components.rider ~= nil and act.doer.components.rider:IsRiding() then
        act.doer.components.rider:Dismount()
        return true
    end
end
AddAction(MOUNTNIU)
AddAction(DISMOUNTNIU)
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.MOUNTNIU, "doshortaction"))

local Dismountniu = GLOBAL.require "widgets/dismountniu"
local function AddDismountniu(self) 
	self.dismountniu = self:AddChild(Dismountniu(self.owner))
end
AddClassPostConstruct("widgets/controls", AddDismountniu)
---==================================
--brush and unsaddle
local  BRUSH = Action( 3,  false , false )
local  UNSADDLE = Action(3,  false , false )
BRUSH.id = "BRUSH"
BRUSH.str = "Brush"
UNSADDLE.id = "UNSADDLE"
UNSADDLE.str = "Unsaddle"
BRUSH.fn = function(act)
    if act.target.components.combat ~= nil and act.target.components.combat.target ~=nil then
        return false, "TARGETINCOMBAT"
    elseif act.target.components.brushable ~= nil then
        act.target.components.brushable:Brush(act.doer, act.invobject)
        return true
    end
end
UNSADDLE.fn = function(act)
    if act.target.components.combat ~= nil and act.target.components.combat.target ~=nil then
        return false, "TARGETINCOMBAT"
    elseif act.target.components.rideable ~= nil then
        act.doer:PushEvent("saddle", { target = act.target })
        act.target.components.rideable:SetSaddle(act.doer, nil)
        return true
    end
end
AddAction(BRUSH)
AddAction(UNSADDLE)
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.BRUSH, "dolongaction"))
AddStategraphActionHandler("wilson", ActionHandler(ACTIONS.UNSADDLE, "unsaddle"))

AddComponentPostInit("wisecracker", function(self)
    self.inst:ListenForEvent("mountwounded", function(inst, data)
    inst.components.talker:Say(STRINGS.CHARACTERS.GENERIC.ANNOUNCE_MOUNT_LOWHEALTH)
    end)
end)

AddComponentPostInit("combat", function(self)
	local O_CalcDamage = self.CalcDamage
	local O_GetAttacked = self.GetAttacked
	function self:CalcDamage(target, weapon, multiplier)
		if self.inst.components.rider ~= nil and self.inst.components.rider:IsRiding() then
			local basedamage 
			if weapon ~= nil and weapon.components.weapon.attackrange ~= nil  and weapon.components.weapon.attackrange > 5  then  
				basedamage = weapon.components.weapon.damage
			else
            local mount = self.inst.components.rider:GetMount()
            if mount ~= nil and mount.components.combat ~= nil then
                basedamage = mount.components.combat.defaultdamage
            end
            local saddle = self.inst.components.rider:GetSaddle()
            if saddle ~= nil and saddle.components.saddler ~= nil then
                basedamage = basedamage + saddle.components.saddler:GetBonusDamage()
            end	
			end
		return basedamage
		else
		return O_CalcDamage(self,target, weapon, multiplier)
		end
	end
	function self:GetAttacked(attacker, damage, weapon, stimuli)
		if self.inst.components.rider and  self.inst.components.rider:IsRiding() then
		local blocked = false
		local player = GetPlayer()
		local init_damage = damage
		self.lastattacker = attacker
		if damage and (self.inst.components.rider and self.inst.components.rider.mount and self.inst.components.rider.mount.components.health) then
			local health = self.inst.components.rider.mount.components.health
			if damage > 0 and health:IsInvincible() == false then
				health:DoDelta(-damage, "combat", attacker and attacker.prefab or "NIL")
			else
				blocked = true
			end	
		end
		if self.inst.SoundEmitter then
			local hitsound = self:GetImpactSound(self.inst, weapon)
			if hitsound then
				self.inst.SoundEmitter:PlaySound(hitsound)
			end
			if self.hurtsound then
				self.inst.SoundEmitter:PlaySound(self.hurtsound)
			end
		end
		if not blocked then
			if self.inst.components.rider and self.inst.components.rider.mount and self.inst.components.rider.mount.components.health then
				self.inst:PushEvent("mountattacked", {attacker = attacker, damage = damage, weapon = weapon, stimuli = stimuli})
			end
			if self.onhitfn then
				self.onhitfn(self.inst, attacker, damage)
			end
			if attacker then
				attacker:PushEvent("onhitother", {target = self.inst, damage = damage, stimuli = stimuli})
				if attacker.components.combat and attacker.components.combat.onhitotherfn then
					attacker.components.combat.onhitotherfn(attacker, self.inst, damage, stimuli)
				end	
			end
		else
			self.inst:PushEvent("blocked", {attacker = attacker, weapon = weapon})
		end
		return not blocked
		else
		return O_GetAttacked(self,attacker, damage, weapon, stimuli)
		end
	end
end)

TUNING.ANJIANXIANIU = GetModConfigData("Key_O_To_Dismount")
if TUNING.ANJIANXIANIU then 
	local function anjiandismount()
	if GetPlayer().components.rider and  GetPlayer().components.rider:IsRiding() then
		if GetPlayer().components.playercontroller.enabled == true then
			GetPlayer():PushEvent("dismountniu")
		end
	end
	end
	GLOBAL.TheInput:AddKeyDownHandler(GLOBAL.KEY_O, anjiandismount)
end

AddComponentPostInit('playeractionpicker',function(self)
	local OldFn = self.DoGetMouseActions
	function self:DoGetMouseActions(force_target)
		local second_action = nil
		local target = nil
		local ents = TheInput:GetAllEntitiesUnderMouse()
			for k,v in pairs(ents) do
				if v:HasTag("player") then
					target = v
					break
				end
			end
		local target_in_light = target and target:IsValid() and target.Transform and TheSim:GetLightAtPoint(target.Transform:GetWorldPosition()) > TUNING.DARK_CUTOFF
		local position = TheInput:GetWorldPosition()
		if target_in_light then
		do
			local acts = self:GetRightClickActions(target, position)
			if acts[1] and acts[1].action == ACTIONS.DISMOUNTNIU then
				second_action = acts[1]
			end
		end
		end
		if second_action then
			return nil,second_action 
		else
			return
			OldFn(self,force_target)
		end
	end
end)

--[[---for debug 
local x,y,z = GetPlayer().Transform:GetWorldPosition() 
local beef = SpawnPrefab('beefalo') 
beef.Transform:SetPosition(x,y,z)
beef.components.domesticatable:DeltaDomestication(1) 
beef.components.domesticatable:DeltaObedience(1) 
beef.components.domesticatable:DeltaTendency(TENDENCY.ORNERY, 1)
beef:SetTendency()
beef.components.domesticatable:BecomeDomesticated()
beef.components.rideable:SetSaddle(nil, SpawnPrefab("saddle_war"))
beef.components.hunger:SetPercent(0.5)
-----]]
	