local assets =
{
    Asset("ANIM", "anim/staffcastfx_mount.zip"),
}
local function staffcastfx_mount()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()


        inst:AddTag("FX")

        inst.Transform:SetFourFaced()

        inst.AnimState:SetBank("staffcastfx_mount")
        inst.AnimState:SetBuild("staffcastfx_mount")
        inst.AnimState:PlayAnimation("staffcastfx_mount")
        --inst.SetUp = SetUp

        inst.persists = false

        --Anim is padded with extra blank frames at the end
        inst:ListenForEvent("animover", inst.Remove)

        return inst
end

return 
    Prefab("staffcastfx_mount", staffcastfx_mount, assets)
